'* Filename    :  2-                           *
'* Revision    : 4.0                                                           *
'* Controller  : ATMEGA8                                                       *
'* Compiler    : BASCOM-AVR 2.0.6.1                                            *
'* Author      : MACTEPOK                                                      *
'*******************************************************************************
$regfile = "m8def.dat"                                      ' 
$crystal = 8000000                                          ' 
'$sim
$lib "mcsbyte.lbx"                                          '  

Config Pinc.0 = Input : Portc.0 = 1                         ' 
Config Pinc.1 = Input : Portc.1 = 1                         ' 
Config Pinc.2 = Input : Portc.2 = 1                         ' 

Config Portd = Output : Config Portb = Output               '      

Load1 Alias Portb.3                                         ' 1
Load2 Alias Portb.4                                         ' 2

Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' 
Dim W As Byte , Y As Byte , X As Byte , I As Byte , Z As Byte , Chislo(6) As Integer , Light As Integer , Light_on As Word , Light_off As Word , Pressure As Integer , Pressure_on As Word , Pressure_off As Word , Sostoyanie As Byte , Sostoyanie_2 As Byte , Copy_print As Integer , Copy_print_sec As Integer , _print As Integer , _print_sec As Integer , Pokazaniya As Integer , View_menu As Byte , Booton_flag As Bit , Booton_flag_2 As Bit , Count As Word , Error_flag As Bit
Dim Razryad_1 As Byte , Razryad_2 As Byte , Temp_najatiya As Byte , Indicator As Byte
Dim Menu_punkt As Byte                                      ' 
Dim Set_flag As Bit                                         '   
Dim Podskaz_flag As Bit , Podskaz_flag_sec As Bit           '      
Dim Default As Eram Byte At &H14                            ' EEPROM        


A Alias Portd.2 : B Alias Portd.6 : C Alias Portb.7 : D Alias Portb.2       ',     
E Alias Portd.0 : F Alias Portb.6 : G Alias Portd.7 : H Alias Portb.5       '
Dig1 Alias Portd.3 : Dig2 Alias Portd.4 : Dig3 Alias Portd.1       '  ,      1 
Dig1_sec Alias Portd.5 : Dig2_sec Alias Portb.0 : Dig3_sec Alias Portb.1       '  ,      2 

For X = 1 To 6                                              '    ,       
Chislo(x) = 11
Next
'*********** ___    (/) ___ *********************
   Readeeprom Indicator , 26
   If Pinc.0 = 0 Then                                       '   ,  .
      For X = 1 To 200
         If X = 150 Then                                    '   
            Set Booton_flag
            Toggle Indicator.3                              '   ()  .    
            Writeeeprom Indicator , 26
            If Indicator = &B00000000 Then                  '    ,      
               Reset A : Reset B : Reset C : Reset D : Reset E : Reset F : Reset G : Reset H
               Set Dig1 : Set Dig2 : Set Dig3 : Set Dig1_sec : Set Dig2_sec : Set Dig3_sec
            End If
            If Indicator = &B00001000 Then                  '    K,      
               Set A : Set B : Set C : Set D : Set E : Set F : Set G : Set H
               Reset Dig1 : Reset Dig2 : Reset Dig3 : Reset Dig1_sec : Reset Dig2_sec : Reset Dig3_sec
            End If
            Waitms 1500
            Exit For
         End If
         If Pinc.0 = 1 Then Exit For
         Waitms 10
      Next
   End If
'*******************************************************************************
If Default = 255 Then                                       '  ,  Default=255
   Light_off = 600                                          '  
   Light_on = 400
   Pressure_off = 700
   Pressure_on = 500
   Indicator = &B00000000                                   '  . Indicator = &B00001000  
   Razryad_1 = &B11101110
   Razryad_2 = &B11101110
   Writeeeprom Light_on , 0                                 '   EEPROM  ON1
   Writeeeprom Light_off , 5                                '   EEPROM  OFF1
   Writeeeprom Pressure_on , 10                             '   EEPROM  ON2
   Writeeeprom Pressure_off , 14                            '   EEPROM  OFF2
   Writeeeprom Razryad_1 , 16
   Writeeeprom Razryad_2 , 17
   Writeeeprom Indicator , 26
   Default = 100                                            '   100(,   255)        
End If
   Readeeprom Light_on , 0                                  '   EEPROM  ON1
   Readeeprom Light_off , 5                                 '   EEPROM  OFF1
   Readeeprom Pressure_on , 10                              '   EEPROM  ON2
   Readeeprom Pressure_off , 14                             '   EEPROM  OFF2
   Readeeprom Razryad_1 , 16
   Readeeprom Razryad_2 , 17

   Config Timer0 = Timer , Prescale = 8 : On Timer0 Pulse   '   0        
   Config Timer1 = Timer , Prescale = 1 : On Timer1 Bootons '   1        
   Enable Interrupts : Enable Timer0 : Enable Timer1        '  ,  0,    1
   Start Timer0 : Start Timer1
   Start Adc                                                '  

Do
   If X > 40 Then                                           '    ,     ======
      Stop Timer0 : Stop Timer1                             '     
      Light = Getadc(5)                                     '  (  0  1023) (1 )
      Light = 1023 - Light                                  ' ===========
'      Light = Light / 10.23                                 '          ==============
      If Light > 999 Then Light = 999                       '   ( Light > 100,   Light = 100) =
      Pressure = Getadc(4)                                  '   (2 )
      Pressure = 1023 - Pressure
'      Pressure = Pressure / 10.23                           '  ====== Dig4,5,6
      If Pressure > 999 Then Pressure = 999
   X = 0                                                    '
   End If
   Start Timer0 : Start Timer1
   If Light_on < Light_off Then                             '  ON1 < OFF1   
      If Light <= Light_on Then Sostoyanie = 1              '    ON1,    1
      If Light >= Light_off Then Sostoyanie = 0             '    OFF1,     1
   Else                                                     '  ON1 > OFF1   
      If Light >= Light_on Then Sostoyanie = 1              '    ON1,    1
      If Light <= Light_off Then Sostoyanie = 0             '    OFF1,     1
   End If

   If Sostoyanie = 1 Then Set Load1 Else Reset Load1        ' 1  

   If Pressure_on < Pressure_off Then                       '  ON2 < OFF2   
      If Pressure <= Pressure_on Then Sostoyanie_2 = 1      '    ON2,     2
      If Pressure >= Pressure_off Then Sostoyanie_2 = 0     '    OFF2,     2
   Else                                                     '  ON2 > OFF2   
      If Pressure >= Pressure_on Then Sostoyanie_2 = 1      '    ON2,     2
      If Pressure <= Pressure_off Then Sostoyanie_2 = 0     '    OFF2,     2
   End If

   If Sostoyanie_2 = 1 Then Set Load2 Else Reset Load2      ' 2  

Loop

'*******************************************************************************
' 

Pulse:
   If View_menu <> 0 And Error_flag = 0 Then Incr Count     '        ,  ,        (~  5 )
   If Count > 7000 Then                                     '     
      Count = 0                                             ' 
      View_menu = 0                                         '      
   End If
'   H = 1                                                    '    
   Stop Timer0                                              '  0
   Select Case View_menu                                    '    ,      
      Case 0 :
         _print = Light                                     '  . 1     1 
         _print_sec = Pressure                              '  . 2     2 
      Case 1 :
         _print = Light_on                                  ' 1     ON1
         _print_sec = Pressure                              ' 2     2 
      Case 2 :
         _print = Light_off                                 ' 1     OFF1
         _print_sec = Pressure                              ' 2     2 
      Case 3 :
         _print = Light                                     ' 1     1 
         _print_sec = Pressure_on                           ' 2     ON2
      Case 4 :
         _print = Light                                     ' 1     1 
         _print_sec = Pressure_off                          ' 2     OFF2
   End Select

   If Podskaz_flag = 0 Then                                 '    1  ,    
      Copy_print = _print                                   '   

         For I = 1 To 3                                     '       3 
         Chislo(i) = _print Mod 10                          '        _print(123 mod 10 = 3)
         _print = _print / 10                               '      _print (123/10=12)
         Next

'      If Copy_print < 100 Then Chislo(3) = 11               '   < 100,    3   == 
'      If Copy_print < 10 Then Chislo(2) = 11                '    < 10,    2  =====================
   End If
   If Podskaz_flag_sec = 0 Then                             '    2  ,    
      Copy_print_sec = _print_sec                           '   
         For I = 4 To 6                                     '       3 
         Chislo(i) = _print_sec Mod 10                      '        _print(123 mod 10 = 3)
         _print_sec = _print_sec / 10                       '      _print_sec (123/10=12)
         Next
 '      If Copy_print_sec < 100 Then Chislo(6) = 11          '   < 100,    3     
'      If Copy_print_sec < 10 Then Chislo(5) = 11           '    < 10,    2   ====== Dig4,5,6
   End If


   If Indicator = 0 Then                                    '     
      Reset Dig1 : Reset Dig2 : Reset Dig3 : Reset Dig1_sec : Reset Dig2_sec : Reset Dig3_sec       '    
   Else
      Set Dig1 : Set Dig2 : Set Dig3 : Set Dig1_sec : Set Dig2_sec : Set Dig3_sec       '   K
   End If

   Incr W : If W > 6 Then W = 1                             '     
   Y = 0
   Gosub Look : A = Z                                       '    Look,        
   Gosub Look : B = Z
   Gosub Look : C = Z
   Gosub Look : D = Z
   Gosub Look : E = Z
   Gosub Look : F = Z
   Gosub Look : G = Z

   Select Case W                                            '  ()   (w).        ()
      Case 1 :
         If Indicator = 0 Then
            Set Dig1
            If Podskaz_flag = 0 Then H = Razryad_1.1 Else H = 1
         Else
            Reset Dig1
            If Podskaz_flag = 0 Then
               H = Razryad_1.1
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 2 :
         If Indicator = 0 Then
            Set Dig2
            If Podskaz_flag = 0 Then H = Razryad_1.2 Else H = 1
         Else
            Reset Dig2
            If Podskaz_flag = 0 Then
               H = Razryad_1.2
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 3 :
         If Indicator = 0 Then
            Set Dig3
            If Podskaz_flag = 0 Then H = Razryad_1.3 Else H = 1
         Else
            Reset Dig3
            If Podskaz_flag = 0 Then
               H = Razryad_1.3
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 4 :
         If Indicator = 0 Then
            Set Dig1_sec
            If Podskaz_flag_sec = 0 Then H = Razryad_2.1 Else H = 1
         Else
            Reset Dig1_sec
            If Podskaz_flag = 0 Then
               H = Razryad_2.1
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 5 :
         If Indicator = 0 Then
            Set Dig2_sec
            If Podskaz_flag_sec = 0 Then H = Razryad_2.2 Else H = 1
         Else
            Reset Dig2_sec
            If Podskaz_flag = 0 Then
               H = Razryad_2.2
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 6 :
         If Indicator = 0 Then
            Set Dig3_sec
            If Podskaz_flag_sec = 0 Then H = Razryad_2.3 Else H = 1
         Else
            Reset Dig3_sec
            If Podskaz_flag = 0 Then
               H = Razryad_2.3
               Toggle H
            Else
               H = 0
            End If
         End If
   End Select
'

   Start Timer0
Return
'
Look:                                                       '        ,    
   Z = Chislo(w) * 7 : Z = Y + Z                            '       DATA. W -      1..2..3, Y    (A=0 B=1 C=2...G=7)
   If Indicator = 0 Then
      Z = Lookup(z , Cifri_oa)                              '           -OA
   Else
      Z = Lookup(z , Cifri_ok)                              '-OK
   End If
   Incr Y                                                   'Y    (A=0 B=1 C=2...). Chislo(w) * 7 -      Data.Z = Y + Z -      .
Return
'
Cifri_oa:
'             |Chislo(i)|  |
Data 0 , 0 , 0 , 0 , 0 , 0 , 1                              '0
Data 1 , 0 , 0 , 1 , 1 , 1 , 1                              '1
Data 0 , 0 , 1 , 0 , 0 , 1 , 0                              '2
Data 0 , 0 , 0 , 0 , 1 , 1 , 0                              '3
Data 1 , 0 , 0 , 1 , 1 , 0 , 0                              '4
Data 0 , 1 , 0 , 0 , 1 , 0 , 0                              '5
Data 0 , 1 , 0 , 0 , 0 , 0 , 0                              '6
Data 0 , 0 , 0 , 1 , 1 , 1 , 1                              '7
Data 0 , 0 , 0 , 0 , 0 , 0 , 0                              '8
Data 0 , 0 , 0 , 0 , 1 , 0 , 0                              '9
Data 1 , 1 , 1 , 1 , 1 , 1 , 0                              '10           "-"
Data 1 , 1 , 1 , 1 , 1 , 1 , 1                              '11           ""
Data 1 , 1 , 1 , 0 , 0 , 0 , 1                              '12           "L"
Data 1 , 1 , 0 , 1 , 0 , 1 , 0                              '13           "n"
Data 0 , 1 , 1 , 1 , 0 , 0 , 0                              '14           "F"
Data 0 , 1 , 1 , 0 , 0 , 0 , 0                              '15           "E"
Data 1 , 1 , 1 , 1 , 0 , 1 , 0                              '16           "r"

'*******************************************************************************
Cifri_ok:
'             |Chislo(i)|  |
Data 1 , 1 , 1 , 1 , 1 , 1 , 0                              '0
Data 0 , 1 , 1 , 0 , 0 , 0 , 0                              '1
Data 1 , 1 , 0 , 1 , 1 , 0 , 1                              '2
Data 1 , 1 , 1 , 1 , 0 , 0 , 1                              '3
Data 0 , 1 , 1 , 0 , 0 , 1 , 1                              '4
Data 1 , 0 , 1 , 1 , 0 , 1 , 1                              '5
Data 1 , 0 , 1 , 1 , 1 , 1 , 1                              '6
Data 1 , 1 , 1 , 0 , 0 , 0 , 0                              '7
Data 1 , 1 , 1 , 1 , 1 , 1 , 1                              '8
Data 1 , 1 , 1 , 1 , 0 , 1 , 1                              '9
Data 0 , 0 , 0 , 0 , 0 , 0 , 1                              '10           "-"
Data 0 , 0 , 0 , 0 , 0 , 0 , 0                              '11           "" 
Data 0 , 0 , 0 , 1 , 1 , 1 , 0                              '12           "L"
Data 0 , 0 , 1 , 0 , 1 , 0 , 1                              '13           "n"
Data 1 , 0 , 0 , 0 , 1 , 1 , 1                              '14           "F"
Data 1 , 0 , 0 , 1 , 1 , 1 , 1                              '15           "E"
Data 0 , 0 , 0 , 0 , 1 , 0 , 1                              '16           "r"

'*******************************************************************************
'
'*******************************************************************************
'  
Bootons:
   Incr X
   Stop Timer1
      If Pinc.0 = 0 And Booton_flag = 0 And Pinc.1 = 1 And Pinc.2 = 1 Then Gosub Set_mode       '   
      If Set_flag = 1 And Pinc.0 = 1 Then                   '         
         If Pinc.1 = 0 Then Gosub Up_const
         If Pinc.2 = 0 Then Gosub Down_const
      End If
      If Pinc.0 = 0 And Pinc.1 = 0 And View_menu = 0 And Booton_flag_2 = 0 Then Gosub Set_h_led1
      If Pinc.0 = 0 And Pinc.2 = 0 And View_menu = 0 And Booton_flag_2 = 0 Then Gosub Set_h_led2

      If Pinc.0 = 1 And Pinc.1 = 1 And Pinc.2 = 1 Then Reset Booton_flag       '   
      If Pinc.0 = 1 Then Reset Booton_flag_2
   Start Timer1 : Start Timer0
Return
'*******************************************************************************
'
'
Set_mode:
   Enable Interrupts : Enable Timer0 : Start Timer0

   Set Set_flag                                             '      (  )
   Set Booton_flag                                          '     (  ,      )
   Count = 0                                                '     
   If Light_on = Light_off Or Pressure_on = Pressure_off Then Gosub Errors       '  .     
   Incr View_menu                                           '   
   If View_menu > 4 Then View_menu = 0                      '  4  , 0 -  

      Select Case View_menu                                 '   
       Case 0 :                                             ' ---
           Set Podskaz_flag
           Set Podskaz_flag_sec
           Chislo(1) = 10
           Chislo(2) = 10
           Chislo(3) = 10
           Chislo(4) = 10
           Chislo(5) = 10
           Chislo(6) = 10
           Reset Set_flag                                   '
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom Pressure_off , 14                    '   OFF2  EEPROM

       Case 1 :                                             ' On1
           Set Podskaz_flag                                 '    ()  1 
           Chislo(1) = 1
           Chislo(2) = 13
           Chislo(3) = 0
           Waitms 500

       Case 2 :                                             ' OF1
           Set Podskaz_flag                                 '    ()  1 
           Chislo(1) = 1
           Chislo(2) = 14
           Chislo(3) = 0
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom Light_on , 0                         '   ON1  EEPROM

       Case 3 :                                             ' On2
           Set Podskaz_flag_sec                             '    ()  2 
           Chislo(4) = 2
           Chislo(5) = 13
           Chislo(6) = 0
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom Light_off , 5                        '   OFF1  EEPROM

       Case 4 :                                             ' OFF2
           Set Podskaz_flag_sec                             '    ()  2 
           Chislo(4) = 2
           Chislo(5) = 14
           Chislo(6) = 0
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom Pressure_on , 10                     '   ON2  EEPROM

           End Select

   Reset Podskaz_flag
   Reset Podskaz_flag_sec
Return
'
Errors:
   Set Error_flag                                           '   
   If Light_on = Light_off Then
      Set Podskaz_flag
      Chislo(1) = 16
      Chislo(2) = 16                                        '  Err    1 
      Chislo(3) = 15
      Waitms 500
      Chislo(1) = 11
      Chislo(2) = 11
      Chislo(3) = 11
      Waitms 500
      Chislo(1) = 16
      Chislo(2) = 16
      Chislo(3) = 15
      Waitms 500
      Chislo(1) = 11
      Chislo(2) = 11
      Chislo(3) = 11
      Waitms 500
   End If
   If Pressure_on = Pressure_off Then
      Set Podskaz_flag_sec
      Chislo(4) = 16
      Chislo(5) = 16                                        '  Err    2 
      Chislo(6) = 15
      Waitms 500
      Chislo(4) = 11
      Chislo(5) = 11
      Chislo(6) = 11
      Waitms 500
      Chislo(4) = 16
      Chislo(5) = 16
      Chislo(6) = 15
      Waitms 500
      Chislo(4) = 11
      Chislo(5) = 11
      Chislo(6) = 11
      Waitms 500
   End If
   Select Case View_menu                                    '   ,       
      Case 0 :                                              '   EEPROM  
      Case 1 :
         Readeeprom Light_on , 0
      Case 2 :
         Readeeprom Light_off , 5
      Case 3 :
          Readeeprom Pressure_on , 10
      Case 4 :
         Readeeprom Pressure_off , 14
   End Select
   Decr View_menu                                           '      ( )
   Count = 0 : Reset Error_flag
Return
'
Up_const:
   Enable Interrupts : Enable Timer0 : Start Timer0
   Count = 0
   Select Case View_menu
      Case 1 :
            If Light_on < 999 Then Incr Light_on
      Case 2 :
            If Light_off < 999 Then Incr Light_off
      Case 3 :
            If Pressure_on < 999 Then Incr Pressure_on
      Case 4 :
            If Pressure_off < 999 Then Incr Pressure_off
   End Select
   Waitms 20
Return
'
'
Down_const:
   Enable Interrupts : Enable Timer0 : Start Timer0
   Count = 0
   Select Case View_menu
      Case 1 :
            If Light_on > 0 Then Decr Light_on
      Case 2 :
            If Light_off > 0 Then Decr Light_off
      Case 3 :
            If Pressure_on > 0 Then Decr Pressure_on
      Case 4 :
            If Pressure_off > 0 Then Decr Pressure_off
   End Select
   Waitms 20
Return
'
'
Set_h_led1:
   Set Booton_flag_2
   Rotate Razryad_1 , Left
   Stop Timer1 : Stop Timer0
   Writeeeprom Razryad_1 , 16
Return
'
'
Set_h_led2:
   Set Booton_flag_2
   Rotate Razryad_2 , Left
   Stop Timer1 : Stop Timer0
   Writeeeprom Razryad_2 , 17
Return